unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, ComCtrls,
  StdCtrls, Menus, ActnList,fpjson, jsonparser,TypInfo;

type

  { TForm1 }

  TForm1 = class(TForm)
    CountLabel: TLabel;
    DateiOeffnen: TMenuItem;
    dtLabelKey: TLabel;
    dtLabelValue: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    MainMenu1: TMainMenu;
    Memo6: TMemo;
    MenuItem1: TMenuItem;
    ProgrammBeenden: TMenuItem;
    WeatherArray: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    Memo4: TMemo;
    Memo5: TMemo;
    PageControl1: TPageControl;
    OpenDialog1: TOpenDialog;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    VorButton: TButton;
    ZurueckButton: TButton;
    procedure DateiOeffnenClick(Sender: TObject);
    procedure ProgrammBeendenClick(Sender: TObject);
    procedure ScrollWetterDaten();
    procedure VorButtonClick(Sender: TObject);
    procedure ZurueckButtonClick(Sender: TObject);
  private

  public

  end;

var
  Form1         : TForm1;
  jObject       : TJSONObject;
  jData         : TJSONData;
  jArray        : TJSONArray;
  wettercnt     : integer;
  maxcount      : integer;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.ProgrammBeendenClick(Sender: TObject);
begin
  close;
end;

procedure TForm1.ScrollWetterDaten();
var
  aWeather : TJSONArray;
  maincnt  : integer;
  lz_14      : string;
begin
    maincnt := 0;
    lz_14 := '              ';
    CountLabel.Caption := 'WetterDaten '+IntToStr(wettercnt+1)+' / '+ IntToStr(maxcount);
    jData      := jArray.Items[wettercnt];
    memo3.Text := jData.FormatJSON;

    // Item dt
    dtLabelKey.Caption := TJSONObject(jData).Names[0];  // Item Key dt
    dtLabelValue.Caption :=jData.Items[0].AsString;     // Item Value
    // end dt

    // Object main
    Label1.Caption := 'Object   '+ TJSONObject(jData).Names[1];

    jObject := TJSONObject(jData).Objects[TJSONObject(jData).Names[1]];

    Label2.Caption := IntToStr(jObject.Count) + '  Key/Value Pairs';

    memo4.Clear;
    for maincnt := 0 to jObject.Count - 1 do
     begin
      memo4.Lines.Append(jObject.Names[maincnt] + lz_14 + jObject.Items[maincnt].AsString) ;
     end;
    // end Object main

    // Array weather
    aWeather := TJSONObject(jData).Arrays[TJSONObject(jData).Names[2]];
    memo5.Clear;
    memo5.Text :=aWeather.FormatJSON;
    // end Array weather

    // Object clouds
    jObject := TJSONObject(jData).Objects[TJSONObject(jData).Names[3]];
    Label3.Caption := TJSONObject(jData).Names[3] +'   '+ jObject.Names[0] + '   '+ jObject.Items[0].AsString;
    // end Object clouds

    // Object wind
    jObject := TJSONObject(jData).Objects[TJSONObject(jData).Names[4]];
    Label4.Caption := TJSONObject(jData).Names[4];

    memo6.Clear;
    memo6.Lines.Append(jObject.Names[0] + lz_14 + jObject.Items[0].AsString) ;
    memo6.Lines.Append(jObject.Names[1] + lz_14 + jObject.Items[1].AsString) ;
    // end object wind

    // Item visibility
    Label5.Caption := TJSONObject(jData).Names[5] + '   ' + TJSONObject(jData).Items[5].AsString;
    // Item pop
    Label6.Caption := TJSONObject(jData).Names[6] + '   ' + TJSONObject(jData).Items[6].AsString;

    // Object snow
    jObject := TJSONObject(jData).Objects[TJSONObject(jData).Names[7]];

    Label7.Caption := TJSONObject(jData).Names[7] +'   '+   jObject.Names[0]  + '   '+ jObject.Items[0].AsString;
     // end Object snow

    // Object sys
    jObject := TJSONObject(jData).Objects[TJSONObject(jData).Names[8]];
    Label8.Caption := TJSONObject(jData).Names[8] +'   '+   jObject.Names[0]  + '   '+ jObject.Items[0].AsString;
    // end Object sys

    // Item dt_txt
    Label9.Caption := TJSONObject(jData).Names[9] + '   ' + TJSONObject(jData).Items[9].AsString;

end;

procedure TForm1.VorButtonClick(Sender: TObject);
begin
  wettercnt +=1;
  if wettercnt > maxCount-1 then wettercnt := 0;
  ScrollWetterDaten();
end;

procedure TForm1.ZurueckButtonClick(Sender: TObject);
begin
  wettercnt -=1;
  if wettercnt < 0 then wettercnt := maxCount-1;
  ScrollWetterDaten();
end;

procedure TForm1.DateiOeffnenClick(Sender: TObject);
var
  sourceStream  : TFileStream;
      jObject   : TJSONObject;

      begin

      if opendialog1.Execute then
       begin
          sourceStream := TFileStream.Create( opendialog1.FileName, fmOpenRead);
          jData := GetJSON(sourceStream);
          memo1.Clear;
          memo1.Text:= jData.FormatJSON;                // gesamte Json Structure

          jObject := TJSONObject(jData);
          jArray  :=   JObject.Arrays[ TJSONObject(jData).Names[3]];
          memo2.Text:= jArray.FormatJSON;                  // gesamtes list array
          maxcount := jArray.Count;                   // Anzahl der ArrayElemente

          CountLabel.Caption :=  IntToStr(maxcount);  // WetterDaten [0..2]
           ScrollWetterDaten();
           sourceStream.Free;
        end
       else
         ShowMessage('Sie müssen zuerst eine Datei laden!');
      end;


end.

